﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F01302;
(function (F01302) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u0418\u0422\u041E\u0413\u0418"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetP2Sp2Data("\u0424\u0414\u0414_310_\u0422\u041E"));
            result.push(this.GetP2Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_1", F01302.P2Sp2Sp3StrKeys.SeniorOfficers));
            result.push(this.GetP2Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_2", F01302.P2Sp2Sp3StrKeys.MiddleOfficers));
            result.push(this.GetP2Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_3", F01302.P2Sp2Sp3StrKeys.JuniorOfficers));
            result.push(this.GetP2Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_4", F01302.P2Sp2Sp3StrKeys.Ensigns));
            result.push(this.GetP2Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_5", F01302.P2Sp2Sp3StrKeys.OtherContracts));
            result.push(this.GetP2Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_6", F01302.P2Sp2Sp3StrKeys.CadetsWithContract));
            result.push(this.GetP2Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_7", F01302.P2Sp2Sp3StrKeys.CadetsWithoutContract));
            result.push(this.GetP2Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_8", F01302.P2Sp2Sp3StrKeys.Inductees));
            result.push(this.GetP3Sp2Data("\u0424\u0414\u0414_320_\u0422\u041E"));
            result.push(this.GetP3Sp3Data("\u0414\u043E\u043F\u0412\u044B\u043F\u043B\u0430\u0442\u044B_320_\u0422\u041E"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetInfoUZData("\u0421\u0432\u0435\u0434\u0435\u043D\u0438\u044F_\u0423\u0417", this._document.P5RefKosguTable));
            result.push(this.GetRationaleUZData("\u041E\u0431\u043E\u0441\u043D\u043E\u0432\u0430\u043D\u0438\u0435_\u0423\u0417"));
            result.push(this.GetNpaUZData("\u041D\u041F\u0410_\u0423\u0417", this._document.P5RefObjDescNpaTable, this._document.P5RefObjTable));
            result.push(this.GetCountMonthForCalcData("\u041C\u0435\u0441\u044F\u0446\u044B", this._document.CountMonthForCalcTable));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.P1TotalTable;
            var keys = [2, 3, 16, -1, -1, -1, -1, -1, -1, -1, -1, 15, -1, 1, -1, 100];
            var strCodes = ["02", "03", "04", "09", "13", "14", "07", "08", "11", "12", "10", "01", "06", "15", "16", "100"];
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    if (keys[i] === 15) {
                        var arr = new Array(yearsCount);
                        if (srcTable.Locate(srcTable.StrKeyField.Id, 1)) {
                            for (var j = 0; j < yearsCount; j++) {
                                arr[j] = srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0;
                            }
                        }
                        if (srcTable.Locate(srcTable.StrKeyField.Id, 16)) {
                            for (var j = 0; j < yearsCount; j++) {
                                arr[j] = (arr[j] || 0) - (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0);
                            }
                        }
                        for (var j = 0; j < yearsCount; j++) {
                            template += "b" + (3 + j) + "=\"" + (arr[j] || 0) + "\" ";
                        }
                    }
                    else {
                        template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                    }
                }
                template += "/>";
                srcData.push(template);
            }
            for (var i = 1; i <= yearsCount + 1; i++) {
                srcData.push("<c ID=\"SUM_" + i + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var isSecond266 = (kosguData[i].Code === "266") && (kosguData[i - 1].Code === "266");
                var template = "<a ID=\"" + (isSecond266 ? kosguData[i].Code + "_2" : kosguData[i].Code) + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id, kosguData) {
            var srcData = [];
            var yearsCount = ObasStageSettings.YearsCount;
            for (var i = 1; i < kosguData.length; i++) {
                if (kosguData[i].Code === "211" || kosguData[i].Code === "213") {
                    var template = "<a ID=\"" + kosguData[i].Code + "\" b1=\"" + kosguData[i].Code + "\" b2=\"" + kosguData[i].Code + "\" b3=\"0\" ";
                    for (var j = 1; j < yearsCount + 1; j++) {
                        template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                    }
                    template += "/>";
                    srcData.push(template);
                }
            }
            var template = "<a ID=\"total\" b3=\"0\" ";
            for (var j = 1; j < yearsCount + 1; j++) {
                template += "b" + (3 + j) + "=\"" + (kosguData[0].Data[j] || 0) + "\" ";
            }
            template += "/>";
            srcData.push(template);
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp2Data = function (barsTableId) {
            var rowsTable = this._document.P2Sp2Sp3RowsTable;
            var dataTable = this._document.P2Sp2DataTable;
            var srcTable = this._document.P2Sp2DataTransTable;
            var yearsCount = ObasStageSettings.YearsCount;
            var FillDataArr = function (arr, fieldId, startIndex) {
                for (var j = 0; j < yearsCount; j++) {
                    arr[startIndex + j] = srcTable.GetFieldValue(fieldId + j.toString());
                }
            };
            var GenYearData = function (arr, startIndex) {
                var result = "";
                for (var j = 0; j < yearsCount; j++) {
                    result += "b" + (startIndex + j) + "=\"" + (arr[startIndex + j] || 0) + "\" ";
                }
                return result;
            };
            var srcDataArr = new Array(13);
            for (var i = 1; i < srcDataArr.length; i++) {
                srcDataArr[i] = new Array(26);
                if (rowsTable.Locate(rowsTable.BarsCode.Id, ObasHelper.FillWithCharacter(i.toString(), 2))) {
                    if (srcTable.Locate(dataTable.StrKeyField.Id, rowsTable.RecordKey.Value)) {
                        FillDataArr(srcDataArr[i], dataTable.EmplCount.Id, 3);
                        FillDataArr(srcDataArr[i], dataTable.SalaryCount.Id, 8);
                        FillDataArr(srcDataArr[i], dataTable.Fot.Id, 12);
                        FillDataArr(srcDataArr[i], dataTable.AddFot.Id, 16);
                        FillDataArr(srcDataArr[i], dataTable.TotalFot.Id, 20);
                        FillDataArr(srcDataArr[i], dataTable.Salary.Id, 23);
                    }
                }
            }
            for (var i = 4; i < srcDataArr.length - 1; i++) {
                for (var j = 3; j < srcDataArr[i].length; j++) {
                    if (i < 7) {
                        srcDataArr[2][j] = (srcDataArr[2][j] || 0) + (srcDataArr[i][j] || 0);
                    }
                    if (([8, 9, 10, 23, 24, 25].indexOf(j) === -1)) {
                        if (i < 11) {
                            srcDataArr[1][j] = (srcDataArr[1][j] || 0) + (srcDataArr[i][j] || 0);
                        }
                        srcDataArr[12][j] = (srcDataArr[12][j] || 0) + (srcDataArr[i][j] || 0);
                    }
                }
            }
            var srcData = [];
            for (var i = 1; i < srcDataArr.length; i++) {
                if (i !== 3) {
                    var template = "<a ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" ";
                    template += GenYearData(srcDataArr[i], 3);
                    template += GenYearData(srcDataArr[i], 8);
                    template += GenYearData(srcDataArr[i], 12);
                    template += GenYearData(srcDataArr[i], 16);
                    template += GenYearData(srcDataArr[i], 20);
                    template += GenYearData(srcDataArr[i], 23);
                    template += "b27=\"0\" b28=\"0\" b29=\"0\" />";
                    srcData.push(template);
                }
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp3Data = function (barsTableId, strKey) {
            var dataTable = this._document.P2Sp3DataTable;
            var srcTable = this._document.P2Sp3DataTransTable;
            var fieldsIds = [dataTable.StrKeyField.Id, dataTable.Payment.ForeignKey.Id, dataTable.NpaType.ForeignKey.Id, dataTable.NpaFields.NpaDate.Id, dataTable.NpaFields.NpaNumber.Id,
                dataTable.NpaFields.NpaName.Id, dataTable.NpaStatus.ForeignKey.Id, dataTable.NpaStatusChangeDate.Id];
            var srcData = [];
            var i = 0;
            while (srcTable.Locate(dataTable.StrKeyField.Id, strKey, true)) {
                var fieldsValues = [];
                for (var j = 0; j < fieldsIds.length; j++) {
                    fieldsValues.push(srcTable.GetFieldValue(fieldsIds[j]));
                }
                dataTable.Locate(fieldsIds, fieldsValues);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Payment.Name || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.AddFot.Id, 7);
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"" + ((dataTable.NpaStatus.Code === "1") ? "true" : "fasle") + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bnpacolumn=\"" + (dataTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b10=\"" + (dataTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(dataTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b12=\"" + (dataTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b13=\"" + (dataTable.NpaStatus.Code || "") + "\" ";
                template += "b15=\"" + (ObasHelper.ConvertToString(dataTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            srcTable.ClearLocateFlag();
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp2Data = function (barsTableId) {
            var dataTable = this._document.P3Sp2DataTable;
            var srcTable = this._document.P3Sp2DataTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate(dataTable.Post.ForeignKey.Id, srcTable.GetFieldValue(dataTable.Post.ForeignKey.Id));
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 2) + "\" ";
                template += "b1=\"" + ((dataTable.Post.Code || "")) + "\" ";
                template += "b1_clone=\"" + ((dataTable.Post.Code || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.EmplCount.Id, 3);
                template += this.GenYearData(srcTable, dataTable.SalaryCount.Id, 8);
                template += this.GenYearData(srcTable, dataTable.Fot.Id, 12);
                template += this.GenYearData(srcTable, dataTable.AddFot.Id, 16);
                template += this.GenYearData(srcTable, dataTable.TotalFot.Id, 21);
                template += this.GenYearData(srcTable, dataTable.Salary.Id, 24);
                template += this.GenYearData(srcTable, dataTable.Indexation.Id, 28);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Sp3Data = function (barsTableId) {
            var dataTable = this._document.P3Sp3DataTable;
            var srcTable = this._document.P3Sp3DataTransTable;
            var fieldsIds = [dataTable.OwnerKey.Id, dataTable.Payment.ForeignKey.Id, dataTable.NpaType.ForeignKey.Id, dataTable.NpaFields.NpaDate.Id, dataTable.NpaFields.NpaNumber.Id,
                dataTable.NpaFields.NpaName.Id, dataTable.NpaStatus.ForeignKey.Id, dataTable.NpaStatusChangeDate.Id];
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var fieldsValues = [];
                for (var j = 0; j < fieldsIds.length; j++) {
                    fieldsValues.push(srcTable.GetFieldValue(fieldsIds[j]));
                }
                dataTable.Locate(fieldsIds, fieldsValues);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Payment.Name || "")) + "\" ";
                template += "b2=\"" + (dataTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b3=\"" + (ObasHelper.ConvertToString(dataTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b4=\"" + (dataTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b5=\"" + (dataTable.NpaFields.NpaName.Value || "") + "\" ";
                template += this.GenYearData(srcTable, dataTable.AddFot.Id, 7);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.GetFieldValue(dataTable.OwnerKey.Id)) + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"" + ((dataTable.NpaStatus.Code === "1") ? "true" : "fasle") + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bnpacolumn=\"" + (dataTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b10=\"" + (dataTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(dataTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b12=\"" + (dataTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b13=\"" + (dataTable.NpaStatus.Code || "") + "\" ";
                template += "b15=\"" + (ObasHelper.ConvertToString(dataTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            srcTable.ClearLocateFlag();
            return { Id: barsTableId, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F01302.ExportRules = ExportRules;
})(F01302 || (F01302 = {}));
