var F03108;
(function (F03108) {
    var InterfaceRules = (function () {
        function InterfaceRules(_document) {
            this._document = _document;
        }
        InterfaceRules.prototype.P2Sp1SheetCanEditEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column === 0) {
                return table.GetKeyBySourceTable(this._document.P2Sp1RecipientDataTable.ParentTable) == null;
            }
            else if (column === 1) {
                return table.GetKeyBySourceTable(this._document.P2Sp1RecipientDataTable) == null;
            }
            return true;
        };
        InterfaceRules.prototype.P2Sp2SheetCanEditEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column === 0) {
                return table.GetKeyBySourceTable(this._document.P2Sp2RecipientDataTable.ParentTable) == null;
            }
            else if (column === 1) {
                return table.GetKeyBySourceTable(this._document.P2Sp2RecipientDataTable) == null;
            }
            return true;
        };
        InterfaceRules.prototype.P3SheetCanEditEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            var table = this._document.Sheets.getValue(sheetId).Table;
            if (column === 0) {
                return table.GetKeyBySourceTable(this._document.P3RecipientDataTable.ParentTable) == null;
            }
            else if (column === 1) {
                return table.GetKeyBySourceTable(this._document.P3RecipientDataTable) == null;
            }
            return true;
        };
        InterfaceRules.prototype.NpaSheetFormatEventHandler = function (sheetId, row, column, groupIndex) {
            var strCodeColumn = 3;
            if (column < strCodeColumn) {
                return SheetFormatCollection.Related;
            }
            else if (column === strCodeColumn + 1 || column === strCodeColumn + 5) {
                return SheetFormatCollection.Spr;
            }
            else if (column === strCodeColumn) {
                return SheetFormatCollection.Default;
            }
            else {
                return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.NpaSheetCalcEventHandler = function (sheetId, row, column, fieldId) {
            if (column === 3) {
                return ObasHelper.FillWithCharacter(row + 1, 3);
            }
            return undefined;
        };
        InterfaceRules.prototype.FilterP2Sp1RecipientsSprTable = function () {
            var pnoSpr = ObasTableCollection.PnoSprTable;
            return ObasTableCollection.RecipientCategorySprTable.RecordKey.Value ===
                pnoSpr.RecipientCategory.LookupByKeys(this._document.P2Sp1PnoDataTable.Pno.ForeignKey.Value);
        };
        InterfaceRules.prototype.FilterP2Sp2RecipientsSprTable = function () {
            var pnoSpr = ObasTableCollection.PnoSprTable;
            return ObasTableCollection.RecipientCategorySprTable.RecordKey.Value ===
                pnoSpr.RecipientCategory.LookupByKeys(this._document.P2Sp2PnoDataTable.Pno.ForeignKey.Value);
        };
        InterfaceRules.prototype.FilterP3RecipientsSprTable = function () {
            var pnoSpr = ObasTableCollection.PnoSprTable;
            return ObasTableCollection.RecipientCategorySprTable.RecordKey.Value ===
                pnoSpr.RecipientCategory.LookupByKeys(this._document.P3PnoDataTable.Pno.ForeignKey.Value);
        };
        InterfaceRules.prototype.NpaEditorOnCanCloseEventHandler = function (buttonResult) {
            if (buttonResult === MessageResults.Cancel) {
                return true;
            }
            else {
                var canAddNpa = ObasTableCollection.NpaSprTable.IsUniqueRow();
                if (!canAddNpa) {
                    Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0423\u0436\u0435 \u0441\u0443\u0449\u0435\u0441\u0442\u0432\u0443\u0435\u0442 \u0442\u0430\u043A\u043E\u0439 \u041D\u041F\u0410", MessageIcons.Error);
                }
                return (canAddNpa && buttonResult === MessageResults.Ok);
            }
        };
        InterfaceRules.prototype.AfterStartEventHandler = function () {
            ObasTableCollection.NpaSprTable.UpdateDataRows(this._document.NpaTable);
        };
        InterfaceRules.prototype.ShiftDataMenuItemClickEventHandler = function () {
            this._document.UpdateRules.ShiftData();
        };
        InterfaceRules.prototype.CopyDataMenuItemClickEventHandler = function () {
            this._document.UpdateRules.CopyData();
        };
        InterfaceRules.prototype.RecalcDataMenuItemClickEventHandler = function () {
            this._document.UpdateRules.RecalcData();
        };
        return InterfaceRules;
    }());
    F03108.InterfaceRules = InterfaceRules;
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        P1Sheet.prototype.IsFooterRow = function (row) {
            return (row === this.RowCount - 1);
        };
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (this.IsFooterRow(row)) {
                if (column > P1Sheet._strCodeColumn) {
                    return SheetFormatCollection.Calc;
                }
                else {
                    return SheetFormatCollection.Default;
                }
            }
            else {
                if (column === P1Sheet._strCodeColumn) {
                    return SheetFormatCollection.Default;
                }
                else {
                    return SheetFormatCollection.Related;
                }
            }
            return undefined;
        };
        P1Sheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            if (!this.IsFooterRow(row)) {
                if (column === P1Sheet._strCodeColumn) {
                    return ObasHelper.FillWithCharacter(row + 1, P1Sheet._strCodeLength);
                }
            }
            return undefined;
        };
        P1Sheet._strCodeColumn = 2;
        P1Sheet._strCodeLength = 3;
        return P1Sheet;
    }(Sheet));
    F03108.P1Sheet = P1Sheet;
    var PxGroupSheet = (function (_super) {
        __extends(PxGroupSheet, _super);
        function PxGroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PxGroupSheet.prototype.StandardCalc = function (param, row, column, info) {
            var sheet = this.GetSheetFromParam(param);
            var curLvl = sheet.GetRowLevel(row) - 1;
            var columnInfo = info.ColumnsInfo[column];
            if (curLvl === 0) {
                var rowInfo = columnInfo.TotalRow;
                if (rowInfo.IsCalculated) {
                    var result = new SheetCalcResult(BaseFormulas.SUM);
                    for (var i = 0; i < sheet.RowCount; i++) {
                        var code = parseInt(sheet.GetCellValue(i, info.CodeInfo.Column));
                        if (code % 1000 === 0) {
                            result.AddCoordinates(new CellCoordinate(i, column));
                        }
                    }
                    return result.ToArray();
                }
            }
            return _super.prototype.StandardCalc.call(this, param, row, column, info);
        };
        PxGroupSheet._totalRowInfo = {
            IsCalculated: false,
            Name: "\u0412\u0441\u0435\u0433\u043E",
            Format: SheetFormatCollection.Default
        };
        PxGroupSheet._totalPbsRowInfo = {
            IsCalculated: false,
            Name: "\u0418\u0442\u043E\u0433\u043E \u043F\u043E \u041F\u0411\u0421",
            Format: SheetFormatCollection.Default
        };
        PxGroupSheet._sprColAllDefault = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.SprOnlyFormatRow],
            TotalRow: SheetRowInfoCollection.Default
        };
        PxGroupSheet._sprColDefaultAll = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.Default],
            TotalRow: SheetRowInfoCollection.Default
        };
        PxGroupSheet._sprColConstAll = {
            Cell: { Type: SheetCellTypes.Spr },
            SubTotalRow: PxGroupSheet._totalPbsRowInfo,
            TotalRow: PxGroupSheet._totalRowInfo
        };
        return PxGroupSheet;
    }(HierarchyYearGroupSheet));
    F03108.PxGroupSheet = PxGroupSheet;
    var P2GroupSheet = (function (_super) {
        __extends(P2GroupSheet, _super);
        function P2GroupSheet() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._curSheetId = "";
            return _this;
        }
        Object.defineProperty(P2GroupSheet.prototype, "SheetInfo", {
            get: function () {
                return P2GroupSheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        P2GroupSheet.prototype.GetEmptyFieldRangeEventHandler = function (sheetId) {
            this._curSheetId = (sheetId || "");
            return [""];
        };
        P2GroupSheet.prototype.GetYearsCaptionCol8EventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            var colNum = this.GetSheetYear(this._curSheetId) - this.Document.Settings.StartYear + 1;
            return "\u0441 1 \u044F\u043D\u0432\u0430\u0440\u044F " + (this.Document.Settings.StartYear) + " \u0433\u043E\u0434\u0430\n(\u0442\u0435\u043A\u0443\u0449\u0435\u0433\u043E \u0444\u0438\u043D\u0430\u043D\u0441\u043E\u0432\u043E\u0433\u043E \u0433\u043E\u0434\u0430),\n\u0440\u0443\u0431/\u0447\u0435\u043B\n(\u0433\u0440. 7 * \u0433\u0440. " + colNum + " \u043F\u043E\u0434\u0440. 5.1)";
        };
        P2GroupSheet.prototype.GetYearsCaptionCol9EventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            var colNum = this.GetSheetYear(this._curSheetId) - this.Document.Settings.StartYear + 1;
            return "\u0441 1 \u0444\u0435\u0432\u0440\u0430\u043B\u044F " + (this.Document.Settings.StartYear) + " \u0433\u043E\u0434\u0430\n(\u0442\u0435\u043A\u0443\u0449\u0435\u0433\u043E \u0444\u0438\u043D\u0430\u043D\u0441\u043E\u0432\u043E\u0433\u043E \u0433\u043E\u0434\u0430),\n\u0440\u0443\u0431/\u0447\u0435\u043B\n(\u0433\u0440. 7 * \u0433\u0440. " + colNum + " \u043F\u043E\u0434\u0440. 5.2)";
        };
        P2GroupSheet._codeInfo = {
            Column: 4,
            Length: 5,
            LevelIncs: [1000, 1000, 1],
            CalcTotalCode: function () {
                return 90100;
            }
        };
        P2GroupSheet._sheetInfo = {
            MaxLevel: 3,
            CodeInfo: P2GroupSheet._codeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                PxGroupSheet._sprColAllDefault,
                PxGroupSheet._sprColDefaultAll,
                PxGroupSheet._sprColConstAll,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.CalcColAllX,
                SheetColumnInfoCollection.CalcColAllX,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.CalcColAllCalc
            ]
        };
        return P2GroupSheet;
    }(PxGroupSheet));
    F03108.P2GroupSheet = P2GroupSheet;
    var P3GroupSheet = (function (_super) {
        __extends(P3GroupSheet, _super);
        function P3GroupSheet() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(P3GroupSheet.prototype, "SheetInfo", {
            get: function () {
                return P3GroupSheet._sheetInfo;
            },
            enumerable: true,
            configurable: true
        });
        P3GroupSheet._codeInfo = {
            Column: 3,
            Length: 5,
            LevelIncs: [1000, 1000, 1],
            CalcTotalCode: function () {
                return 90100;
            }
        };
        P3GroupSheet._sheetInfo = {
            MaxLevel: 3,
            CodeInfo: P3GroupSheet._codeInfo,
            ColumnsInfo: [
                SheetColumnInfoCollection.SprColDefaultTotal,
                PxGroupSheet._sprColAllDefault,
                PxGroupSheet._sprColConstAll,
                SheetColumnInfoCollection.AllDefault,
                SheetColumnInfoCollection.FreeColAllCalc,
                SheetColumnInfoCollection.FreeColAllX,
                SheetColumnInfoCollection.CalcColAllCalc
            ]
        };
        return P3GroupSheet;
    }(PxGroupSheet));
    F03108.P3GroupSheet = P3GroupSheet;
    var IndexationSheet = (function (_super) {
        __extends(IndexationSheet, _super);
        function IndexationSheet(id, _document) {
            var _this = _super.call(this, id, true) || this;
            _this._document = _document;
            return _this;
        }
        IndexationSheet.prototype.GetFieldRangeEventHandler = function (sheetId) {
            if (sheetId === void 0) { sheetId = ""; }
            return this._document.CommonRules.GetDollarRateYearsFieldRangeEventHandler(sheetId, this._document.Settings.YearsCount);
        };
        IndexationSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            return SheetFormatCollection.Free;
        };
        IndexationSheet.prototype.GetYearsCaptionEventHandler = function (tableId, index, defaultCaption, fieldCaption) {
            return (this._document.Settings.StartYear + index).toString();
        };
        return IndexationSheet;
    }(Sheet));
    F03108.IndexationSheet = IndexationSheet;
})(F03108 || (F03108 = {}));
