var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F03110;
(function (F03110) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u041E\u0411\u0410\u0421"));
            result.push(this.GetP3NpaData("\u041D\u041F\u0410"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push({ Id: "\u0420\u0430\u0441\u0447\u0435\u0442\u041E\u0411\u0410\u0421", Data: [] });
            result.push(this.GetP2Data("\u0424\u0430\u043A\u0442\u043E\u0440\u044B\u0420\u0430\u0441\u0447\u0435\u0442\u0430\u041F\u041D\u041E"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423", kosguData));
            return result;
        };
        ExportRules.prototype.GenYearData = function (srcTable, fieldId, startIndex) {
            var result = "";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                result += "b" + (startIndex + j) + "=\"" + (srcTable.GetFieldValue(fieldId + j.toString()) || 0) + "\" ";
            }
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.P1TotalTable;
            var keys = [1, 100, 2];
            var strCodes = ["01", "100", "02"];
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    template += "b2=\"0\" ";
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (6 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b2=\"0\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" b7=\"0\" b8=\"0\" ";
                }
                template += "b9=\"0\" b10=\"0\" b11=\"0\" />";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3NpaData = function (barsTableId) {
            var srcTable = this._document.TableP3Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b5=\"False\" ";
                template += "b8=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b9=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b10=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b11=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b12=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "b13=\"" + (srcTable.Pno.Code || "") + "\" ";
                template += "b14=\"" + (srcTable.Recipient.Code || "") + "\" ";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Data = function (barsTableId) {
            var dataTable = this._document.RecipientDataTable;
            var srcTable = this._document.RecipientDataTransTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                dataTable.Locate([dataTable.Pno.ForeignKey.Id, dataTable.Recipient.ForeignKey.Id], [srcTable.GetFieldValue(dataTable.Pno.ForeignKey.Id), srcTable.GetFieldValue(dataTable.Recipient.ForeignKey.Id)]);
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + ((dataTable.Pno.Code || "")) + "\" ";
                template += "b2_clone=\"" + ((dataTable.Recipient.Code || "")) + "\" ";
                template += "b2=\"" + ((dataTable.Recipient.Code || "")) + "\" ";
                template += this.GenYearData(srcTable, dataTable.RecipientsCount.Id, 4);
                template += this.GenYearData(srcTable, dataTable.Pay.Id, 8);
                template += this.GenYearData(srcTable, dataTable.Obas.Id, 12);
                template += this.GenYearData(srcTable, dataTable.AddObas.Id, 16);
                template += this.GenYearData(srcTable, dataTable.TotalObas.Id, 20);
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var kosguTable = ObasTableCollection.KosguSprTable;
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                var template = "<a ID=\"" + (i - 1) + "\" ";
                if (kosguTable.Locate(kosguTable.Code.Id, kosguData[i].Code)) {
                    template += "b1=\"" + (kosguTable.Name.Value || "") + "\" ";
                }
                else {
                    template += "b1=\"\" ";
                }
                template += "b2=\"" + (kosguData[i].Code || "") + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "b7=\"0\" b8=\"0\" b9=\"0\" ";
                template += "bFILTERINGCOLUMN=\"" + (i + 1) + "\" ";
                template += "b10=\"0\" b11=\"0\" b12=\"0\" b13=\"0\" b14=\"0\" b15=\"0\" b16=\"0\" b17=\"0\" b18=\"0\" />";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id, kosguData) {
            var strCodes = ["261", "262", "263", "290", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                srcData.push("<a ID=\"" + strCodes[i] + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F03110.ExportRules = ExportRules;
})(F03110 || (F03110 = {}));
