var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F03400;
(function (F03400) {
    var InterfaceRules = (function (_super) {
        __extends(InterfaceRules, _super);
        function InterfaceRules() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InterfaceRules.prototype.SheetNpaFormatEventHandler = function (sheetId, row, column, groupIndex) {
            switch (column) {
                case 0:
                case 1:
                    return SheetFormatCollection.Related;
                case 2:
                    return SheetFormatCollection.Default;
                case 3:
                case 7:
                    return SheetFormatCollection.Spr;
                default:
                    return SheetFormatCollection.Free;
            }
        };
        InterfaceRules.prototype.SheetNpaCalcEventHandler = function (sheetId, row, column, fieldId) {
            if (column === 2) {
                return ObasHelper.FillWithCharacter((row + 1).toString(), 3);
            }
        };
        InterfaceRules.prototype.FilterNPAStatuses = function () {
            var npaStatusesTable = ObasTableCollection.NpaStatusesSprTable;
            return npaStatusesTable.RecordKey.Value === 1 || npaStatusesTable.RecordKey.Value === 2;
        };
        InterfaceRules.prototype.NpaEditorOnCanCloseEventHandler = function (buttonResult) {
            if (buttonResult === MessageResults.Cancel) {
                return true;
            }
            else {
                var canAddNpa = ObasTableCollection.NpaSprTable.IsUniqueRow();
                if (!canAddNpa) {
                    Client.ShowMessage("\u041E\u0448\u0438\u0431\u043A\u0430", "\u0423\u0436\u0435 \u0441\u0443\u0449\u0435\u0441\u0442\u0432\u0443\u0435\u0442 \u0442\u0430\u043A\u043E\u0439 \u041D\u041F\u0410", MessageIcons.Error);
                }
                return (canAddNpa && buttonResult === MessageResults.Ok);
            }
        };
        InterfaceRules.prototype.AfterStartEventHandler = function () {
            ObasTableCollection.NpaSprTable.UpdateDataRows(this._document.TableP3Npa);
        };
        return InterfaceRules;
    }(BaseInterfaceRules));
    F03400.InterfaceRules = InterfaceRules;
    var P1SheetRows;
    (function (P1SheetRows) {
        P1SheetRows[P1SheetRows["Fot"] = 0] = "Fot";
        P1SheetRows[P1SheetRows["AddFot"] = 1] = "AddFot";
        P1SheetRows[P1SheetRows["Total"] = 2] = "Total";
    })(P1SheetRows || (P1SheetRows = {}));
    var P1Sheet = (function (_super) {
        __extends(P1Sheet, _super);
        function P1Sheet(id, _document) {
            var _this = _super.call(this, id, false) || this;
            _this._document = _document;
            return _this;
        }
        P1Sheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            if (column > 1) {
                switch (row) {
                    case P1SheetRows.Fot:
                        return SheetFormatCollection.Related;
                    case P1SheetRows.AddFot:
                        return SheetFormatCollection.Free;
                    case P1SheetRows.Total:
                        return SheetFormatCollection.Calc;
                }
            }
            return SheetFormatCollection.Default;
        };
        P1Sheet.prototype.EditingCellEventHandler = function (sheetId, row, column, fieldId, rowLevel) {
            return ((column > 0) && (row === P1SheetRows.AddFot));
        };
        return P1Sheet;
    }(Sheet));
    F03400.P1Sheet = P1Sheet;
    var P2GroupSheet = (function () {
        function P2GroupSheet(_document) {
            this._document = _document;
        }
        P2GroupSheet.prototype.FormatEventHandler = function (sheetId, row, column, groupIndex) {
            return this._document.CommonRules.StandardFormat(sheetId, row, column, P2GroupSheet._sheetInfo);
        };
        P2GroupSheet.prototype.CalcEventHandler = function (sheetId, row, column, fieldId) {
            return this._document.CommonRules.StandardCalc(sheetId, row, column, P2GroupSheet._sheetInfo);
        };
        return P2GroupSheet;
    }());
    P2GroupSheet._totalRowInfo = {
        IsCalculated: false,
        Name: "Всего",
        Format: SheetFormatCollection.Default
    };
    P2GroupSheet._totalGrantRowInfo = {
        IsCalculated: false,
        Name: "Итого по стипендии",
        Format: SheetFormatCollection.Default
    };
    P2GroupSheet._freeColConstAll = {
        Cell: { Type: SheetCellTypes.Free },
        SubTotalRow: [P2GroupSheet._totalGrantRowInfo],
        TotalRow: P2GroupSheet._totalRowInfo
    };
    P2GroupSheet._freeColAllDefault = {
        Cell: { Type: SheetCellTypes.Free },
        SubTotalRow: [SheetRowInfoCollection.Default, SheetRowInfoCollection.FreeOnlyFormatRow],
        TotalRow: SheetRowInfoCollection.Default
    };
    P2GroupSheet._sheetInfo = {
        MaxLevel: 2,
        CodeInfo: {
            Column: 2,
            Length: 7,
            LevelIncs: [100, 1],
            CalcTotalCode: function () {
                return 9010100;
            }
        },
        ColumnsInfo: [
            SheetColumnInfoCollection.SprColDefaultTotal,
            P2GroupSheet._freeColConstAll,
            SheetColumnInfoCollection.AllDefault,
            SheetColumnInfoCollection.FreeColAllCalc,
            SheetColumnInfoCollection.FreeColAllX,
            SheetColumnInfoCollection.CalcColAllCalc
        ]
    };
    F03400.P2GroupSheet = P2GroupSheet;
})(F03400 || (F03400 = {}));
