var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F04300;
(function (F04300) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(document) {
            return _super.call(this, document) || this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1CalFactorsData("\u0424\u0430\u043A\u0442\u043E\u0440\u044B\u0420\u0430\u0441\u0447\u0435\u0442\u0430"));
            result.push(this.GetP1CalData("\u0420\u0430\u0441\u0447\u0435\u0442"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetP2NpaData("\u041D\u041F\u0410"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423", kosguData));
            return result;
        };
        ExportRules.prototype.GetP1CalFactorsData = function (barsTableId) {
            var srcTable = this._document.TableP1;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 2) + "\" ";
                template += "b\u041D\u0430\u0438\u043C\u0435\u043D\u043E\u0432\u0430\u043D\u0438\u0435=\"" + (srcTable.Name.Value || "") + "\" ";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (7 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "b1=\"" + (srcTable.Inn.Value || "") + "\" ";
                template += "b2=\"" + (srcTable.Kpp.Value || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP1CalData = function (barsTableId) {
            var srcTable = this._document.TableP1;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 2) + "\" ";
                template += "b1=\"" + (srcTable.Inn.Value || "") + "\" ";
                template += "b2=\"" + (srcTable.Kpp.Value || "") + "\" ";
                template += "b\u041D\u0430\u0438\u043C\u0435\u043D\u043E\u0432\u0430\u043D\u0438\u0435=\"" + (srcTable.Name.Value || "") + "\" ";
                template += "b4=\"" + (srcTable.Okved.Code || "") + "\" ";
                template += "b5=\"" + (srcTable.Target.Value || "") + "\" ";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (7 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                var template = "<a ID=\"" + kosguData[i].Code + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (3 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetP2NpaData = function (barsTableId, strKey) {
            var srcTable = this._document.TableNpa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 2) + "\" ";
                template += "b\u041D\u0430\u0438\u043C\u0435\u043D\u043E\u0432\u0430\u043D\u0438\u0435=\"" + (srcTable.ParentTable.Name.Value || "") + "\" ";
                template += "b8=\"" + ((srcTable.NpaStatus.Code === "1") ? "true" : "fasle") + "\" ";
                template += "b1=\"" + (srcTable.ParentTable.Inn.Value || "") + "\" ";
                template += "b2=\"" + (srcTable.ParentTable.Kpp.Value || "") + "\" ";
                template += "b9=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b10=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b11=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "bstate=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "bDateChanState=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            srcTable.ClearLocateFlag();
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 1; i < kosguData.length; i++) {
                srcData.push("<a ID=\"" + kosguData[i].Code + "\" b1=\"" + kosguData[i].Code + "\" b2=\"" + kosguData[i].Code + "\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            srcData.push("<a ID=\"total\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F04300.ExportRules = ExportRules;
})(F04300 || (F04300 = {}));
