var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08600;
(function (F08600) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(_document) {
            var _this = _super.call(this, _document) || this;
            _this._document = _document;
            return _this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP2Data("\u041E\u0431\u044A\u0451\u043C\u044B_\u0411\u0410"));
            result.push(this.GetAnalyticRespredelenieData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041E\u0411\u0410\u0421"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423"));
            result.push(this.GetInfoUZData("\u0421\u0432\u0435\u0434\u0435\u043D\u0438\u044F_\u0423\u0417", this._document.P2RefKosguTable));
            result.push(this.GetRationaleUZData("\u041E\u0431\u043E\u0441\u043D\u043E\u0432\u0430\u043D\u0438\u0435_\u0423\u0417"));
            result.push(this.GetNpaUZData("\u041D\u041F\u0410_\u0423\u0417", this._document.P2RefObjDescNpaTable, this._document.P2RefObjTable));
            return result;
        };
        ExportRules.prototype.GetP2Data = function (barsTableId) {
            var srcTable = this._document.P1Table;
            var keys = [1, -1, -1];
            var strCodes = ["010", "020", "100"];
            var yearsCount = ObasStageSettings.YearsCount;
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < yearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            for (var i = 1; i <= yearsCount + 1; i++) {
                srcData.push("<c ID=\"SUM_" + i + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticRespredelenieData = function (barsTableId) {
            var srcData = [];
            srcData.push("<a ID=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u0412\u0441\u0435\u0433\u043E, \u0438\u0437 \u043D\u0438\u0445:\" />");
            srcData.push("<a ID=\"1\" b4=\"0\" b5=\"0\" b6=\"0\" barservice=\"\u041D\u0435\u0440\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u043D\u044B\u0439 \u043E\u0441\u0442\u0430\u0442\u043E\u043A\" />");
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((i === 0) ? "200" : kosguData[i].Code) + "\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (2 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "b6=\"0\" b7=\"0\" b8=\"0\" />";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id) {
            var strCodes = ["262", "226", "290", "total"];
            var srcData = [];
            for (var i = 0; i < strCodes.length; i++) {
                srcData.push("<a ID=\"" + strCodes[i] + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F08600.ExportRules = ExportRules;
})(F08600 || (F08600 = {}));
