var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F08920;
(function (F08920) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(document) {
            return _super.call(this, document) || this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetP1Data("\u0418\u0422\u041E\u0413\u0418"));
            result.push(this.GetP2Data("\u0420\u0443\u0431\u043B\u0438"));
            result.push(this.GetP3Data("\u0412\u0430\u043B\u044E\u0442\u0430"));
            result.push(this.GetP2NpaData("\u041D\u041F\u0410_\u0420\u0443\u0431\u043B\u0438"));
            result.push(this.GetP3NpaData("\u041D\u041F\u0410_\u0412\u0430\u043B\u044E\u0442\u0430"));
            result.push(this.GetRateDollarData("\u041A\u0443\u0440\u0441"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetAnalyticRaspredelenieData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435"));
            var kosguData = this._document.AnalyticsDataTable.CollectKosguData();
            result.push(this.GetRaspredelenieKosguData("\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041F\u043E\u041A\u041E\u0421\u0413\u0423", kosguData));
            result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423", kosguData));
            return result;
        };
        ExportRules.prototype.GetP1Data = function (barsTableId) {
            var srcTable = this._document.TableP1;
            var keys = [2, 3, 1, 100];
            var strCodes = ["01", "02", "03", "100"];
            var srcData = [];
            for (var i = 0; i < keys.length; i++) {
                var template = "<a ID=\"" + strCodes[i] + "\" ";
                if (srcTable.Locate(srcTable.StrKeyField.Id, keys[i])) {
                    for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                        template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                    }
                }
                else {
                    template += "b3=\"0\" b4=\"0\" b5=\"0\" ";
                }
                template += "/>";
                srcData.push(template);
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Data = function (barsTableId) {
            var srcTable = this._document.TableP2;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.GetFieldValue("g2") || "") + "\" ";
                template += "b2=\"" + (srcTable.GetFieldValue("PaymentsType_CODE") || "") + "\" ";
                template += "b2_clone=\"" + (srcTable.GetFieldValue("PaymentsType_CODE") || "") + "\" ";
                template += "b3=\"" + (srcTable.GetFieldValue("g4") || "") + "\" ";
                template += "b4=\"" + (srcTable.GetFieldValue("g5") || "") + "\" ";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (10 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "b21=\"0\" b22=\"0\" b23=\"0\" b24=\"0\" b25=\"0\" b26=\"0\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3Data = function (barsTableId) {
            var srcTable = this._document.TableP3;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.GetFieldValue("g2") || "") + "\" ";
                template += "b2=\"" + (srcTable.GetFieldValue("PaymentsType_CODE") || "") + "\" ";
                template += "b2_clone=\"" + (srcTable.GetFieldValue("PaymentsType_CODE") || "") + "\" ";
                template += "b3=\"" + (srcTable.GetFieldValue("g4") || "") + "\" ";
                template += "b4=\"" + (srcTable.GetFieldValue("g5") || "") + "\" ";
                template += "b5=\"" + (srcTable.GetFieldValue("Currency_CODE") || "") + "\" ";
                template += "b7=\"0\" b8=\"0\" b9=\"0\" ";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (11 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.UsdYearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (15 + j) + "=\"" + (srcTable.GetFieldValue(BaseObasTableFields.YearDataField.GenerateId(j + 1)) || 0) + "\" ";
                }
                template += "b\u043A\u043E\u044D\u0444\u0444\u0438\u0446\u0438\u0435\u043D\u0442=\"0\" bFbcheckbox=\"False\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bcheckbox1=\"False\" ";
                template += "bFILTERINGCOLUMN=\"" + (srcTable.RecordKey.Value) + "\" ";
                template += "b33=\"0\" b34=\"0\" b23=\"0\" b24=\"0\" b25=\"0\" b26=\"0\" b27=\"0\" b28=\"0\" b29=\"0\" b30=\"0\" b31=\"0\" b32=\"0\" bcheckbox2=\"False\" bcheckbox3=\"False\" bcheckbox4=\"False\" bcheckbox5=\"False\" />";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2NpaData = function (barsTableId) {
            var srcTable = this._document.TableP2Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"False\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bFILTERINGCOLUMN=\"" + (srcTable.OwnerKey.Value) + "\" ";
                template += "b6=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b7=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "b8=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP3NpaData = function (barsTableId) {
            var srcTable = this._document.TableP3Npa;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"False\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bFILTERINGCOLUMN=\"" + (srcTable.OwnerKey.Value) + "\" ";
                template += "b6=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b7=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b10=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "b8=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "b11=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                srcData.push(template);
                i++;
            }
            for (var j = 1; j <= ObasStageSettings.YearsCount; j++) {
                srcData.push("<c ID=\"SUM_" + j + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticRaspredelenieData = function (barsTableId) {
            var srcData = [];
            for (var i = 0; i <= 24; i++) {
                srcData.push("<c ID=\"" + ObasHelper.FillWithCharacter(i.toString(), 2) + "\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            }
            srcData.push("<a ID=\"total\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            srcData.push("<a ID=\"diff\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetRaspredelenieKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                if (["-", "220", "250"].indexOf(kosguData[i].Code) === -1) {
                    srcData.push("<a ID=\"" + kosguData[i].Code + "\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
                }
            }
            srcData.push("<a ID=\"total\" b3=\"0\" b4=\"0\" b5=\"0\" b6=\"0\" />");
            return { Id: id, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (id, kosguData) {
            var srcData = [];
            for (var i = 0; i < kosguData.length; i++) {
                var template = "<a ID=\"" + ((kosguData[i].Code === "-") ? "200" : kosguData[i].Code) + "\" ";
                template += "b4=\"0\" b5=\"0\" b6=\"0\" b7=\"0\" b8=\"0\" b9=\"0\" ";
                for (var j = 1; j < ObasStageSettings.YearsCount + 1; j++) {
                    template += "b" + (9 + j) + "=\"" + (kosguData[i].Data[j] || 0) + "\" ";
                }
                template += "b13=\"0\" b14=\"0\" b15=\"0\" b16=\"0\" />";
                srcData.push(template);
            }
            return { Id: id, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F08920.ExportRules = ExportRules;
})(F08920 || (F08920 = {}));
